<?php
// test class
// just don't use
//
class ReportHelper {
	
	function prepareInvoice($bean, $invbean, $user, $i18n, $errors) {
		if ($bean->getAttribute("period")) {
	  		$period = new Period($bean->getAttribute("period"), new DateTime($i18n->getDateFormat()) );
		} else {
			$o_from = new DateTime($i18n->getDateFormat(),$bean->getAttribute("from"));
			$o_to = new DateTime($i18n->getDateFormat(),$bean->getAttribute("to"));
			$period = new Period();
			$period->setPeriod($o_from, $o_to);
		}
		
		if ($user->isManager() && is_array($bean->getAttribute('users'))) $userlist	= join (',', $bean->getAttribute('users'));
	    if (!isset($userlist))	$userlist = $user->getUserId();
	    
		$invoice_items = ReportHelper::getInvoiceItems($userlist,
							$period->getBeginDate(DB_DATEFORMAT),
							$period->getEndDate(DB_DATEFORMAT),
							$bean->getAttribute("project"),
							$bean->getAttribute("activity"));
							
	    $labels = $invbean->getAttributes();
	    $labels["from"] = $period->getBeginDate();
	    $labels["to"] = $period->getEndDate();
	    
		$summs["total"] = $summs["tax"] = $summs["pay"]	= 0;
		$tax = toFloat($invbean->getAttribute("tax"));
		if (!$tax) {
			$tax = 0;
			$labels["tax"] = 0;
		}
	    if ($invoice_items) {
	    	$summ_total = 0;
	    	foreach ($invoice_items as $item) {
	    		$summ_total += $item["ssumm"];
	    	}
	    	$summ_total = round($summ_total,2);
	    	$summs["total"] = $summ_total;
	    	$summs["tax"] = round($summ_total * $tax / 100, 2);
	    	$summs["pay"] = $summ_total + $summs["tax"];
	    }

		
	    ob_start();
	    ?>
	    <style>
			.cell { background-color:white; background:white; }
			.invtitle {font-size : 15pt; font-family : Arial, Helvetica, sans-serif;}
			.tableHeader { color: #000000; font-weight: bold; background-color: #A6CCF7; }
			.tableRow { border-top: solid #e0e0e0 1pt; }
		</style>
	    <table cellpadding="0" cellspacing="0" border="0" width="100%">
			<tr>
				<td colspan="2"><?=$labels["yourcoo"]?></td>
			</tr>
			<tr>
				<td colspan="2">&nbsp;</td>
			</tr>
			<tr>
				<td colspan="2" align="center">
				   <table cellpadding="3" cellspacing="0" border="0" width="100%">
				   <tr><td align="center"><b class="invtitle"><?=$i18n->getKey("form.invoice.caption")?></b> #<?=$labels["number"]?></td></tr>
				   <tr><td><b><?=$i18n->getKey("form.invoice.date")?>:</b>&nbsp;<?=$labels["date"]?></td></tr>
				   <tr><td><b><?=$i18n->getKey("form.invoice.customer")?>:</b>&nbsp;<?=$labels["custcoo"]?></td></tr>
				   <tr><td><b><?=$i18n->getKey("form.invoice.period")?>:</b>&nbsp;<?=$labels["from"]?> - <?=$labels["to"]?></td></tr>
			       </table>
			       <br>
				</td>
			</tr>
			<tr>
				<td colspan="2">
				
				    <table border='0' cellpadding='4' cellspacing='0' width="100%">
			        <tr>
			        	<td width="70%" class="tableHeader" align="center"><B><?=$i18n->getKey("form.invoice.th.username")?></B></td>
			        	<td class="tableHeader" align="center"><B><?=$i18n->getKey("form.invoice.th.time")?></B></td>
			        	<td class="tableHeader" align="center"><B><?=$i18n->getKey("form.invoice.th.rate")?></B></td>
			        	<td class="tableHeader" align="center"><B><?=$i18n->getKey("form.invoice.th.summ")?></B></td>
			        </tr>
			        <? if ($invoice_items) {
			        foreach ($invoice_items as $iit) {
			        ?>
			        <tr>
			        	<td width="70%" class="tableRow"><?=$iit["u_name"]?></td>
			        	<td class="tableRow" align="center"><?=$iit["stotal"]?></td>
			        	<td class="tableRow" align="right"><nobr><?=$user->getCurrency()?> <?=$iit["u_rate"]?></nobr></td>
			        	<td class="tableRow" align="right"><?=$user->getCurrency()?> <?=sprintf("%8.2f",$iit["ssumm"])?></td>
			        </tr>
			        <?
					}
					}?>

			        <tr>
			        	<td colspan="4" class="tableRow">&nbsp;</td>
			        </tr>
			        <tr>
			        	<td class="cell" align="right" colspan="3"><B><?=$i18n->getKey("form.invoice.subtotal")?>:</B></td>
			        	<td class="cell" align="right"><nobr><?=$user->getCurrency()?> <?=sprintf("%8.2f",$summs["total"])?></nobr></td>
			        </tr>
			        <tr>
			        	<td class="cell" align="right" colspan="3"><B><?=$i18n->getKey("form.invoice.tax")?> <?=$labels["tax"]?>%:</B></td>
			        	<td class="cell" align="right"><nobr><?=$user->getCurrency()?> <?=sprintf("%8.2f",$summs["tax"])?></nobr></td>
			        </tr>
			        <tr>
			        	<td class="cell" align="right" colspan="3"><B><?=$i18n->getKey("form.invoice.total")?>:</B></td>
			        	<td class="cell" align="right"><nobr><?=$user->getCurrency()?> <?=sprintf("%8.2f",$summs["pay"])?></nobr></td>
			        </tr>
			        </table>
			        <br>
			
				</td>
			</tr>
			<tr>
			    <td><?=$labels["comment"]?></td>
			</tr>
			</table>
			<?
			$content = ob_get_contents();
			ob_clean();
			return $content;
	}
	
	function prepareTimeSheet($bean, $period, $user, $userlist, $i18n) {
		
	  $db = DB::connect(DSN);
	  if (DB::isError($db)) return false;
	  	
		$array_of_days = $period->getAllDays();
		foreach ($array_of_days as $i) {
		     $dt_tmp = $i->toString(DB_DATEFORMAT);
		     $wdates[$dt_tmp] = $i->getDay();
		     $clean_dates[$dt_tmp] = $i->toString();
		     $dates_work[$dt_tmp] = '';
		}
	  
	    $fields = array();
	    $header = array();
	    $hkeys  = array();
	  
	    array_push ($fields, 'al.al_date');
	    array_push ($header, $i18n->getKey("form.report.th.date"));
	    array_push ($hkeys, 'date');
	    
	    if ($user->isManager()) {
	      array_push ($fields, 'u.u_name');
	      array_push ($header, $i18n->getKey("form.report.th.empllist"));
	      array_push ($hkeys, 'user');
	    }
	    if ($bean->getAttribute("chproject")) {
	      array_push ($fields, 'p.p_name');
	      array_push ($header, $i18n->getKey("form.report.th.project"));
	      array_push ($hkeys, 'project');
	    }
	    if ($bean->getAttribute("chactivity")) {
	      array_push ($fields, 'a.a_name');
	      array_push ($header, $i18n->getKey("form.report.th.activity"));
	      array_push ($hkeys, 'activity');
	    }
	    if ($bean->getAttribute("chstart")) {
	      array_push ($fields, "TIME_FORMAT(al.al_from, '%k:%i')");
	      array_push ($header, $i18n->getKey("form.report.th.start"));
	      array_push ($hkeys, 'start');
	    }
	    if ($bean->getAttribute("chfinish")) {
	      array_push ($fields, "TIME_FORMAT(sec_to_time(time_to_sec(al.al_from) + time_to_sec(al.al_duration)), '%k:%i')");
	      array_push ($header, $i18n->getKey("form.report.th.finish"));
	      array_push ($hkeys, 'finish');
	    }
	    if ($bean->getAttribute("chduration")) {
	      array_push ($fields, "TIME_FORMAT(al.al_duration, '%k:%i')");
	      array_push ($header, $i18n->getKey("form.report.th.duration"));
	      array_push ($hkeys, 'duration');
	    }
	    if ($bean->getAttribute("chnote")) {
	      array_push ($fields, 'al.al_comment');
	      array_push ($header, $i18n->getKey("form.report.th.note"));
	      array_push ($hkeys, 'note');
	    }
	
	   	$q_selproject = ($bean->getAttribute("project") ? " and al.al_project_id = ".$bean->getAttribute("project") : "");
	   	$q_selact = ($bean->getAttribute("activity") ? " and al.al_activity_id = ".$bean->getAttribute("activity") : "");
	   	
	  	$sort_key = (!$bean->getAttribute("groupby") ? "date" : $bean->getAttribute("groupby"));
		$field_list = array_flip($hkeys);
		foreach($field_list as $k=>$v) $empty[$k] = '';
	
		switch ($sort_key) {
	        case "user": $group_field = "u.u_name"; break;
	        case "project": $group_field = "p.p_name"; break;
	        case "activity": $group_field = "a.a_name"; break;
	        default: $group_field = "";
	    }
	
	    $current_project_name = "";
	    $current_activity_name = "";
	    
	    // db query
	    $rows = array(); 
	    $fill_date = array(); 
	    if ($user->isManager()) {
	      $sel_str = "select " . join (', ', $fields) . " from activity_log al, projects p, activities a, users u where al.al_date >= '".$period->getBeginDate(DB_DATEFORMAT)."' and al.al_date <= '".$period->getEndDate(DB_DATEFORMAT)."' and al.al_user_id in (".$userlist.") and p.p_id = al.al_project_id". $q_selproject . $q_selact. " and a.a_id = al.al_activity_id and u.u_id = al.al_user_id order by u.u_name, al.al_date, al.al_from";
	    } else {
	      $sel_str = "select " . join (', ', $fields) . " from activity_log al, projects p, activities a where al.al_date >= '".$period->getBeginDate(DB_DATEFORMAT)."' and al.al_date <= '".$period->getEndDate(DB_DATEFORMAT)."' and al.al_user_id = $user_id and p.p_id = al.al_project_id". $q_selproject . $q_selact. " and a.a_id = al.al_activity_id order by al.al_date, al.al_from";
	    }
	print $sel_str;
	    $sth = $db->prepare($sel_str);
	    $rc = $db->execute($sth);
	    if (DB::isError($rc) == 0) {
	      while ($val = $rc->fetchRow()) {
	        $row = array();
	      	foreach ($hkeys as $fn) {
	      		$row[$fn] = $val[$field_list[$fn]];
	      	}
	      	$row["sortkey"] = $row[$sort_key];
	      	$fill_date[] = array('sortkey'=>$row[$sort_key],'date'=>$val[0]);
	   	    $rows[] = $row;
	   	    if ($bean->getAttribute("chproject")) $current_project_name = $row['project'];
	   	    if ($bean->getAttribute("chactivity")) $current_activity_name = $row['activity'];
	      }
	    } else {
	    	return false;
	    }
	
	    // get subresults
	    $sub_summary = array();
	    if ($group_field) {
	        if ($user->isManager()) {
	          $sel_str = "select $group_field,TIME_FORMAT(sec_to_time(sum(time_to_sec(al.al_duration))), '%k:%i') from activity_log al, projects p, activities a, users u where al.al_date >= '".$period->getBeginDate(DB_DATEFORMAT)."' and al.al_date <= '".$period->getEndDate(DB_DATEFORMAT)."' and al.al_user_id in (".$userlist.") and p.p_id = al.al_project_id". $q_selproject . $q_selact. " and a.a_id = al.al_activity_id and u.u_id = al.al_user_id group by $group_field";
	        } else {
	          $sel_str = "select $group_field,TIME_FORMAT(sec_to_time(sum(time_to_sec(al.al_duration))), '%k:%i') from activity_log al, projects p, activities a where al.al_date >= '".$period->getBeginDate(DB_DATEFORMAT)."' and al.al_date <= '".$period->getEndDate(DB_DATEFORMAT)."' and al.al_user_id = $user_id and p.p_id = al.al_project_id". $q_selproject . $q_selact. " and a.a_id = al.al_activity_id group by $group_field";
	        }
	        $sth = $db->prepare($sel_str);
	        $rc = $db->execute($sth);
	        if (DB::isError($rc) == 0) {
	          while ($val = $rc->fetchRow()) {    
	              $sub_summary[$val[0]] = $val[1];
	          }
	        } else {
	          return false;
	        }
	    } else {
	        $sub_summary['common'] = '1';
	    }
	    
	    if ($bean->getAttribute("chshowidle") && isset($user)) {
	    	if ($sort_key=='user') {
	    		import("UserHelper");
	    		$users = UserHelper::findAllUsers($user);
	    		foreach ($users as $user_it) {
	    			if (!in_array($user_it["u_name"],array_keys($sub_summary))) {
	    				$sub_summary[$user_it["u_name"]] = 0;
	    			}
	    		}
	    	}
	    	if ($sort_key=='project' && ($bean->getAttribute('project')!=null)) {
	    		import("ProjectHelper");
	    		$projects = ProjectHelper::findAllProjects($user);
	    		foreach ($projects as $project) {
	    			if (!in_array($project["p_name"],array_keys($sub_summary))) {
	    				$sub_summary[$project["p_name"]] = 0;
	    			}
	    		}
	    	}
	    	if ($sort_key=='activity' && ($bean->getAttribute('activity')!=null)) {
	    		import("ActivityHelper");
	    		$activities = ActivityHelper::findAllActivity($user);
	    		foreach ($activities as $activity) {
	    			if (!in_array($activity["a_name"],array_keys($sub_summary))) {
	    				$sub_summary[$activity["a_name"]] = 0;
	    			}
	    		}
	    	}
	    	
	    }
	    
	    //build dates period for each subsummary
		if ($bean->getAttribute("chshowidle")) {
		    foreach ($sub_summary as $k=>$v) {
	            foreach ($array_of_days as $i) {
	              $index = $i->toString(DB_DATEFORMAT);
	              $row = $empty;
	    		  $row["date"] = $index;
	    		  $row["sortkey"] = ($sort_key=='date' ? $row[$sort_key] : $k);
	              $toadd = true;
	              foreach ($fill_date as $key) {
	                  if ($key['date']==$index && $key['sortkey']==$row["sortkey"]) {
	                      $toadd = false;
	                  }
	              }
	              if ($toadd) {
	                 $rows[] = $row;
	                 $fill_date[] = array('date'=>$index,'sortkey'=>$row["sortkey"]);
	              }
	            }
		    }
	    }
	    
	    
	    // sort by keys
	    $rows = mu_sort($rows, "sortkey,date");

	    return $rows;
	} // prepareTimeSheet
	
	
	function getInvoiceItems($user_list, $date_from, $date_to, $selproject=0, $selactivity=0) {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
    	$result = array();
    	$db->setFetchMode(DB_FETCHMODE_ASSOC);
		$sth = $db->prepare("select u_name, al_user_id, TIME_FORMAT(sec_to_time(sum(time_to_sec(al_duration))), '%k:%i') as stotal,
                    round(sum(time_to_sec(al_duration))* u_rate /3600,2) as ssumm,
                    u_rate
                    from activity_log, users
                    where al_user_id=u_id and al_user_id in (".$user_list.") and al_date>='$date_from' and al_date<='$date_to'".
                    ($selproject>0 ? " and al_project_id = ".$selproject : "").
                    ($selactivity>0 ? " and al_activity_id = ".$selactivity : "").
                    " group by al_user_id" );
        $rc = $db->execute($sth);
        if (DB::isError($rc) == 0) {
           while ($val = $rc->fetchRow()) {
			  $result[] = $val;
           }
           return $result;
        }
        return false;
	}
}
?>