<?

require_once('DB.php');

class User {
	var $session;
	var $_sessionName = '_usersession';
	var $mUserId;
	var $mBehalfId;
	var $mBehalfName;
	var $mLogin;
	var $mUserName;
	var $mRoles;
	var $mCompanyName;
	var $mCompanyId;
	var $mWww;
	var $mManagerId = 0;
	var $mRate;
	var $mCurrency;

	
	function User($userid="") {
		
    	if( !isset($_SESSION[$this->_sessionName]) && !isset($GLOBALS['HTTP_SESSION_VARS'][$this->_sessionName]) ) {
            $_SESSION[$this->_sessionName] = array();
        }
        
        isset($_SESSION) ? $this->session = &$_SESSION[$this->_sessionName] : $this->session = &$GLOBALS['HTTP_SESSION_VARS'][$this->_sessionName];
        
//print_r($this->session);
        if (!isset($this->session["iduser"])) {
           $this->setUserId($userid);
        } else {
        	$this->mUserId = $this->session["iduser"];
			$this->mLogin = $this->session["login"];
			$this->mUserName = @$this->session["name"];
			$this->mCompanyName = @$this->session["cname"];
			$this->mCompanyId = @$this->session["cid"];
			$this->mWww = @$this->session["www"];
			$this->mRate = @$this->session["rate"];
			$this->mManagerId = @$this->session["manager"];
			$this->mBehalfId = @$this->session["behalfid"];
			$this->mBehalfName = @$this->session["behalfname"];
			$this->mCurrency = @$this->session["currency"];
        }
        if (isset($GLOBALS["SMARTY"])) $GLOBALS["SMARTY"]->assign("user",$this);
//print_r($this);
	}
	
	function getUserId() { return $this->mUserId; }
	function setUserId($id) {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;

    	$db->setFetchMode(DB_FETCHMODE_ASSOC);
	    $sel_str = "select u.u_id, u.u_manager_id, u.u_name, u.u_login, u.u_password, c.c_name, c.c_www, u.u_rate, c.c_currency, u.u_company_id
				from users u, user_status_list usl left join companies c on (u.u_company_id=c.c_id)
				where u.u_id=?
				and u.u_active=usl.usl_id and usl.usl_hidden=0";
    	$sth = $db->prepare($sel_str);
		$data = array($id);
  		$rc = $db->execute($sth,$data);

  		if (DB::isError($rc))
  			return false;
  			
    	$val = $rc->fetchRow();
		if ($val['u_id'] > 0) {
			$this->session["iduser"] = $this->mUserId = $val['u_id'];
			$this->session["login"] = $this->mLogin = $val['u_login'];
			$this->session["name"] = $this->mUserName = $val['u_name'];
			$this->session["cname"] = $this->mCompanyName = $val['c_name'];
			$this->session["cid"] = $this->mCompanyId = $val['u_company_id'];
			if (@$val['c_www']) {
				$href = strpos($val['c_www'],'http://')=== false ? 'http://'.$val['c_www'] : $val['c_www'];
			}
			$this->session["www"] = $this->mWww = @$href;
			$this->session["rate"] = $this->mRate = $val['u_rate'];
			$this->session["currency"] = $this->mCurrency = $val['c_currency'];
			$this->session["manager"] = $this->mManagerId = ($val['u_manager_id']>0 ? $val['u_manager_id'] : 0);
      		return true;
    	} else {
      		return false;
    	}
	}
	
	function getLogin() { return $this->mLogin; }
	function setLogin($login) {$this->mLogin = $login; }
	
	function getUserName() { return $this->mUserName; }
	function setUserName($uname) {$this->mUserName = $uname; }
	
	function getRoles() { return $this->mRoles; }
	function setRoles($roles) {$this->mRoles = $roles; }
	
	function getCompanyName() { return $this->mCompanyName; }
	function setCompanyName($name) {$this->mCompanyName = $name; }
	
	function getCompanyId() { return $this->mCompanyId; }
	function setCompanyId($value) {$this->mCompanyId = $value; }

	
	function getWww() { return $this->mWww; }
	function setWww($www) { $this->mWww = $www; }
	
	function getManagerId() { return $this->mManagerId; }
	function setManagerId($id) { $this->mManagerId = $id; }
	
	function getRate() { return $this->mRate; }
	function setRate($rate) { $this->mRate = $rate; }
	
	function getCurrency() { return $this->mCurrency; }
	function setCurrency($curr) { $this->mCurrency = $curr; }
	
	function getBehalfId() { return $this->mBehalfId; }
	function setmBehalfId($id) { 
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
    	$db->setFetchMode(DB_FETCHMODE_ASSOC);
	    $sel_str = "select u.u_id, u.u_manager_id, u.u_name, u.u_login, u.u_rate
	    	from users u, user_status_list usl, companies c
	    	where u.u_id=? and u.u_manager_id = ? and u.u_active = usl.usl_id and usl.usl_hidden = 0";
    	$sth = $db->prepare($sel_str);
		$data = array($id, $this->mUserId);
  		$rc = $db->execute($sth,$data);

  		if (DB::isError($rc))
  			return false;
  			
    	$val = $rc->fetchRow();
		if ($val['u_id'] > 0) {
			$this->session["behalfid"] = $this->mBehalfId = $val['u_id'];
			$this->session["behalfname"] = $this->mBehalfName = $val['u_name'];
     		return true;
    	} else {
    		if ((int)$id == $this->mUserId) {
				$this->session["behalfid"] = $this->mBehalfId = 0;
				$this->session["behalfname"] = $this->mBehalfName = "";
				return true;
			}
      		return false;
    	}
	}
	
	function getBehalfName() { return $this->mBehalfName; }
	function setBehalfName($name) { $this->mBehalfName = $name; }
	
	function hasRole($role_name) {
		$result = false;
		if (is_array($this->mRoles) && in_array($role_name,$this->mRoles)) $result = true;
		return $result;
	}
	
	function destroy() {
		$this->session = null;
	}
	
	function isManager() {
		return ($this->mManagerId==0 || !isset($this->mManagerId));
	}
	
	function getActiveUser() {
		return ($this->mBehalfId>0 ? $this->mBehalfId : $this->mUserId);
	}
	
	function getActiveManager() {
		return ($this->mBehalfId>0 ? $this->mUserId : $this->mManagerId);
	}
	
}
?>