<?php

import('form.TextField');
	
class DateField extends TextField {
	var $cSysDateFormat = 'm/d/Y';
	
	var $mDateObj;
	var $cClassName	= "DateField";

	function DateField($name) {
		$this->mName	= $name;
		$this->mDateObj	= new DateTime();
		
		if (isset($GLOBALS["I18N"])) {
			$this->setLocalization($GLOBALS["I18N"]);
		}
	}
	
	function setLocalization($i18n)	{
		FormElement::setLocalization($i18n);
		$this->mDateObj->setFormat($i18n->getDateFormat());
	}
	
	function setValueSafe($value)	{
		if (isset($value) && strlen($value)>0) {
			$this->mDateObj->parseVal($value, $this->cSysDateFormat);
			$this->mValue = $this->mDateObj->toString();
		}
	}
	function getValueSafe() {
		if (strlen($this->mValue)>0) {
			$this->mDateObj->parseVal($this->mValue); 
			return $this->mDateObj->toString($this->cSysDateFormat);
		} else {
			return null;
		}
	}
}
?>