<?php

import('form.FormElement');
	

class CheckboxGroup extends FormElement {
    var $mChecked	= false;
    var $mOptions	= array();
    var $mLayout	= "H";
    var $cClassName	= "CheckboxGroup";

	function CheckboxGroup($name,$value="")
	{
		$this->mName			= $name;
		$this->mValue			= $value;
	}

	function setChecked($value)	{ $this->mChecked = $value; }
	function isChecked() { return $this->mChecked; }
	
	function setData($value)	{ $this->mOptions = $value; }
	function getData() { return $this->mOptions; }
	
	function setLayout($value)	{ $this->mLayout = $value; }
	function getLayout() { return $this->mLayout; }
	
	function toStringControl()	{
		if (!$this->isRenderable()) return "";
	    
	    if ($this->mId=="") $this->mId = $this->mName;
	    
	    
	    if ($this->mLayout=="H") {
	    	$_s_bit = "<tr>";
	    	$_b_bit = "<td>";
	    	$_e_bit = "</td>";
	    	$_f_bit = "</tr>";
	    }
	    if ($this->mLayout=="V") {
	    	$_s_bit = "";
	    	$_b_bit = "<tr><td>";
	    	$_e_bit = "</td></tr>";
	    	$_f_bit = "";
	    }
	    
	    $html = "\n\t<table >\n";
	    $i = 0;
	    if (is_array($this->mOptions))
	    foreach ($this->mOptions as $optkey=>$optval) {
	    	$html .= $_s_bit.$_b_bit;
	    	$html .= "<input type=\"checkbox\" name=\"$this->mName[]\" id=\"$this->mId"."_".$i++."\"";
	    	
	    	if (is_array($this->mValue)) {
	    		foreach ($this->mValue as $value) {
	    			if ($value==$optkey && $value!=null)
	    				$html .= " checked=\"true\"";
	    		}
	    	}

		   	$html .= " value=\"".htmlspecialchars($optkey)."\">&nbsp;".htmlspecialchars($optval);
	    	$html .= $_e_bit.$_f_bit."\n";
	    }
	    $html .= "</table>\n";
	    
		/*if ($this->mTabindex!="")
		   $html .= " tabindex=\"$this->mTabindex\"";
		   
		if ($this->mOnChange!="")
		   $html .= " onchange=\"$this->mOnChange\"";
		   
		if ($this->mStyle!="")
		   $html .= " style=\"$this->mStyle\"";*/

		return $html;
	}
}
?>