<?php

// +----------------------------------------------------------------------+
// | WR Time Tracker
// +----------------------------------------------------------------------+
// | Copyright (c) 2004-2005 WR Consulting (http://www.wrconsulting.com)
// +----------------------------------------------------------------------+
// | LIBERAL FREEWARE LICENSE: This source code document may be used
// | by anyone for any purpose, and freely redistributed alone or in
// | combination with other software, provided that the license is obeyed.
// |
// | There are only two ways to violate the license:
// |
// | 1. To redistribute this code in source form, with the copyright
// |    notice or license removed or altered. (Distributing in compiled
// |    forms without embedded copyright notices is permitted).
// |
// | 2. To redistribute modified versions of this code in *any* form
// |    that bears insufficient indications that the modifications are
// |    not the work of the original author(s).
// |
// | This license applies to this document only, not any other software
// | that it may be combined with.
// |
// +----------------------------------------------------------------------+
// | Contributors: Igor Melnik <igor@rivne.com>
// +----------------------------------------------------------------------+

  require_once('config.php');
  if (!require_once('DB.php')) {
  	die ("Unable to require DB module. Please check it<br>\n");
  }

  function setChange($sql) {
  	global $dsn;
	  $db = DB::connect($dsn);
	  if (!DB::isError($db)) {
	  	$sth = $db->prepare($sql);
	    $rc = $db->execute($sth);
	    if (DB::isError($rc) == 0) {
	      print "successful update<br>\n";
	    } else {
	      print "error: ".DB::errorMessage(0);
	    }
	  } else {
	  	print "connect: ".DB::errorMessage(0);
	  }
  }
  
  print "proccess ...<br>\n";
  
  //1.
  setChange("alter table users add u_rate float(6,2) NOT NULL default '0.00'");
  
  //2.
  setChange("CREATE TABLE `invoice_header` (`ih_user_id` int(11) NOT NULL default '0', `ih_number` varchar(20) default NULL, `ih_addr_your` blob, `ih_addr_cust` blob, `ih_comment` varchar(255) default NULL, `ih_tax` float(9,2) default '0.00', PRIMARY KEY  (`ih_user_id`))");

  //3.
  setChange("alter table activities add a_project_id int NOT NULL default 0");
  
  //4.
  setChange("alter table companies add c_currency char(7) NULL");

?>