<?
	/*************************
	* 
	* Path
	*
	*/
	define("APP_DIR",		dirname(__FILE__));
  	define("LIBRARY_DIR",	APP_DIR."/WEB-INF/lib");
  	define("CLASSES_DIR",	APP_DIR."/WEB-INF/clib");
  	define("TEMPLATE_DIR",	APP_DIR."/WEB-INF/templates");
  	define("RESOURCE_DIR",	APP_DIR."/WEB-INF/resources");
  	
    require_once("WEB-INF/config.php");
    if (!defined("DSN")) {
	    die ("Emergency situation! No main configuration file. Please check file 'config.php'<br>\n");
  	}
    require_once(LIBRARY_DIR.'/common.lib.php');
    //import('strutsphp.Controller');
	
	/*************************
	* 
	* HTTP Request
	*
	*/
	import('html.HttpRequest');
	$request = new HttpRequest();
	
  	/*************************
	* 
	* Errors
	*
	*/    
   	import('form.ActionErrors');
    $errors = new ActionErrors();
    
	/*************************
	* 
	* Authorization
	*
	*/    
    // must be here, for correct restore from session
	import('Auth');
	import('User');
    @session_start();
    

	/*************************
	* 
	* Localization
	*
	*/
	$lang = @$_SESSION["stored_lang"];
	if (!$lang) $lang = @$_COOKIE['stored_lang'];
  	$new_lang = $request->getParameter('lng');
  	if ($new_lang != '') {
    	$lang = $new_lang;
  	}
  	if ($lang == '') $lang = 'en';
  	setcookie("stored_lang", $lang, time()+3600);
  	$_SESSION["stored_lang"] = $lang;
  	
	import('I18n');
	$i18n = new I18n();
	$i18n->setSourceDir(RESOURCE_DIR);
    $i18n->load($lang);
    define("CHARSET", "utf-8");
   	//define("CHARSET",$i18n->getCharSet());
    $GLOBALS["I18N"] = &$i18n;

    /*************************
	* 
	* Smarty initialization
	*
	*/
    import('smarty.Smarty');
    $smarty=new Smarty;
    $smarty->use_sub_dirs = false;
    $smarty->template_dir = TEMPLATE_DIR;
    $smarty->compile_dir  = TEMPLATE_DIR . '_c';
//    $smarty->debugging = true;
	$GLOBALS["SMARTY"] = & $smarty;
	$smarty->assign("i18n",$i18n->getKeys());
    $smarty->assign("available_languages",split(",",AVAILABLE_LANG));
    
    $auth = new Auth();
?>